/*
 * This file is part of essential.
 *
 *     essential is free software: you can redistribute it and/or modify
 *     it under the terms of the GNU General Public License as published by
 *     the Free Software Foundation, either version 3 of the License, or
 *     (at your option) any later version.
 *
 *     essential is distributed in the hope that it will be useful,
 *     but WITHOUT ANY WARRANTY; without even the implied warranty of
 *     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *     GNU General Public License for more details.
 *
 *     You should have received a copy of the GNU General Public License
 *     along with essential.  If not, see <http://www.gnu.org/licenses/>.
 */

package net.craftforge.essential.context.spring.config.phases;

import net.craftforge.essential.controller.managers.ResourceManager;
import net.craftforge.essential.controller.phases.AllocationPhase;
import net.craftforge.essential.controller.resolvers.MethodResolver;
import net.craftforge.essential.controller.resolvers.UrlResolver;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.context.annotation.Scope;

import javax.inject.Inject;

/**
 * @author Christian Bick
 * @since 16.01.12
 */
@Configuration
@Scope("request")
public class SpringAllocationPhaseConfig {

    @Inject
    private ResourceManager resourceManager;
    @Inject
    private MethodResolver methodResolver;
    @Inject
    private UrlResolver urlResolver;

    @Bean
    @Scope("request")
    public AllocationPhase provideAllocationPhase() {
        return new AllocationPhase(resourceManager, methodResolver, urlResolver);
    }


}
